/***************************************************************************
                          datadir.cpp  -  description
                             -------------------
    begin                : Sam Mr 1 2003
    copyright            : (C) 2003 by Andr Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "datadir.h"

#include <string>
#include <fstream>
#include <iostream>
#include <stdlib.h>

using namespace std;

string DataDir::datadir="";

bool DataDir::searchDataDir(const string &newDataDir)
{
#ifndef _WIN32 
  ifstream *in;
  bool found = false;
  //falls kein Datenverzeichnis angegeben, startIndex auf 1 setzen
  int searchStartIndex=(newDataDir=="");
  
  string homePath=getenv("HOME");  
  string possibleDirs[] ={ newDataDir,
                           "/usr/share/highlight/",
                           "/usr/local/share/highlight/",
                           "/opt/bin/highlight/",
                           "/opt/highlight/",
                           homePath+"/.highlight/"}  ;

  for (int i=searchStartIndex;i<6;i++)
    {
      in = new ifstream (possibleDirs[i].c_str());
      if (! in->fail())
        {
          datadir=possibleDirs[i];
          found = true;          
        }
      delete in;
      if (found) {
       break;
      }
      else {
        if (!searchStartIndex)
         cerr << "highlight: directory "<<newDataDir<<
                 " specified by data-dir option not found."<<endl
              << "           Searching another standard directory."<<endl;
                 
      }
    }
    return found;
#else
  datadir=newDataDir;
  return true;
#endif
    
  
}


const string &DataDir::getDir()
{
  return datadir;
}

const string DataDir::getLangDefDir()
{
#ifdef _WIN32
  return datadir+"langDefs\\";
#else  
  return datadir+"langDefs/";
#endif  
}

const string DataDir::getThemeDir()
{
#ifdef _WIN32
  return datadir+"themes\\";
#else  
  return datadir+"themes/";
#endif  

}

const string DataDir::getHelpMsgDir()
{
#ifdef _WIN32
  return datadir+"helpmsg\\";
#else
  return datadir+"helpmsg/";
#endif

}
