/***************************************************************************
                          documentstyle.h  -  description
                             -------------------
    begin                : Son Nov 10 2002
    copyright            : (C) 2002 by Andr�Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DOCUMENTSTYLE_H
#define DOCUMENTSTYLE_H

#include <string>
#include <iostream>
#include "configurationreader.h"
#include "datadir.h"
#include "elementstyle.h"
#include "stylecolour.h"


/**Enth�t Informationen ber die Formatierung der Quellldatei
  *@author Andr�Simon
  */

using namespace std;

class DocumentStyle
  {
  private:
    ElementStyle *comment, *keyword, *str, *dstr,
    *escapeChar, *number, *directive, *type, *line;
    StyleColour *bgColour;
    ElementStyle *defaultElem;
    string fontsize;
    bool fileFound;

  public:
    DocumentStyle(const string & styleDefinitionFile);
    ~DocumentStyle();
    
    bool load(const string & styleDefinitionFile);    
    string getFontSize() const;
    StyleColour* getBgColour() const;
    ElementStyle* getDefaultStyle() const;
    ElementStyle* getCommentStyle() const;
    ElementStyle* getKeywordStyle() const;
    ElementStyle* getStringStyle() const;
    ElementStyle* getDirectiveStringStyle() const;
    ElementStyle* getEscapeCharStyle() const;
    ElementStyle* getNumberStyle() const;
    ElementStyle* getDirectiveStyle() const;
    ElementStyle* getTypeStyle() const;
    ElementStyle* getLineStyle() const;
    bool found() const ;
  };

#endif
