/***************************************************************************
                        linewrapper.cpp  -  description
                             -------------------
    begin                : Sa Jan 00 2004
    copyright            : (C) 2004 by Andr�Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef HIGHLIGHTLINEWRAPPER_H
#define HIGHLIGHTLINEWRAPPER_H

#define LB_CHARS " \t[](){}-+<>.:,;"

#include <string>
#include <iostream>

#include "stringtools.h"

namespace highlight {

/**
Klasse mit Methoden zum automatischen Zeilenumbruch

@author Andre Simon
*/
class LineWrapper{
public:
    LineWrapper(unsigned int maxlength, bool indentAfterOpenBraces);
    ~LineWrapper();

    bool hasMoreLines();
    void setLine(const std::string  newline);
    std::string  getNextLine();

private:
    const unsigned int MAX_LINE_LENGTH;
    
    std::string line, wsPrefix;        
    unsigned int index;
    unsigned int wsPrefixLength;
    bool hasMore, indentAfterOpenBraces;
    bool redefineWsPrefix;
};

}

#endif
