/***************************************************************************
                          xslfocode.h  -  description
                             -------------------
    begin                : Do 11.12.2003
    copyright            : (C) 2003 by Andr�Simon
    email                : andre.simon1@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef XSLFO_H
#define XSLFO_H


#include <string>
#include <sstream>
#include <iostream>
#include <fstream>

#include "codeparser.h"
#include "version.h"

/**
  *@author Andr�Simon
  */

class XslFoCode : public highlight::CodeParser
  {
  public:
    XslFoCode( highlight::LanguageDefinition &langDef,const string &cssStyle,
               bool printLineNumbers=false,   bool fragment=false, bool fopCompatible=false,
               int numSpaces=0, int wrapStyle=0);
    XslFoCode();
    ~XslFoCode();

    void printHeader(const string & title);
    void printFooter();
    void printBody();

  private:
    bool fopOutput;
    stringstream snl;
    string styleDefinition;    
    virtual string maskCharacter(unsigned char );    
    string getOpenTag(ElementStyle * elem=NULL);    
    string getNewLine();    
  };

#endif
